//+------------------------------------------------------------------+
//|                                              CTG_Structure-1.mq4 |
//|                                                CompanyName "CTG" |
//|                                     http://chaostradinggroup.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, ChaosTradingGroup.com"
#property link      "http://ChaosTradingGroup.com"

#property indicator_chart_window
#property indicator_buffers 8

#property indicator_color1 Red
#property indicator_color2 Orange
#property indicator_color3 Yellow
#property indicator_color4 Green
#property indicator_color5 DeepSkyBlue
#property indicator_color6 Blue
#property indicator_color7 Violet
#property indicator_color8 Magenta
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_width4  2
#property  indicator_width5  2
#property  indicator_width6  2
#property  indicator_width7  2
#property  indicator_width8  2



//---- indicator parameters
extern int Period1=8;
extern double k3=0.8;
extern int xdist=4;
extern int Future=0;
extern double Futurek4=0.7;
extern int Center=0;
extern int Mirror=0;
extern int Bars1=10;
extern int color1=0;
extern int Refresh=1;
int Color1=0;

//---- indicator buffers
double ExtBullBuffer[];
double ExtBull1Buffer[];
double ExtBull2Buffer[];
double ExtBull3Buffer[];
double ExtBull4Buffer[];
double ExtBull5Buffer[];
double ExtBull6Buffer[];
double ExtBull7Buffer[];


//----
int ExtCountedBars=0,limit,MA_Method=0,s,r,we,l1,MA_Period,sd1,r1,r2,k,a1,a2,wq,z,s1,m=0,o,e,a7,q,d,w1,w2,rs,rs1,az=0,az2;
double Bull,special=0,Bull1,Bull2,Bear8,n10,bars2,ty,ty1,y1,razmer,n20,Bull3,Bull4,Bull0,w0,Bull5,Bull6,Bear,Bear1,Bear2,Bear3,Bear4,Bear5,Bear6,Bear7,l,k1,n1,n2,a,z1,z2,oblmin,oblmax;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
   string short_name;
//---- drawing settings
if (color1==0) 
{


   SetIndexStyle(0,DRAW_LINE,EMPTY, 2,C'255,13,13' );
   SetIndexStyle(1,DRAW_LINE,EMPTY, 2,C'255,134,0' );
   SetIndexStyle(2,DRAW_LINE,EMPTY, 2,C'251,201,0');
   SetIndexStyle(3,DRAW_LINE,EMPTY, 2,C'51,255,0' );
   SetIndexStyle(4,DRAW_LINE,EMPTY, 2,C'0,201,251');
   SetIndexStyle(5,DRAW_LINE,EMPTY, 2,C'13,98,255' );
   SetIndexStyle(6,DRAW_LINE,EMPTY, 2,C'156,21,255');
   SetIndexStyle(7,DRAW_ARROW,EMPTY, 2,Magenta);

}

if (color1!=0) 
{

   SetIndexStyle(0,DRAW_LINE,EMPTY, 2,C'255,128,128' );
   SetIndexStyle(1,DRAW_LINE,EMPTY, 2,C'255,179,94' );
   SetIndexStyle(2,DRAW_LINE,EMPTY, 2,C'255,236,157');
   SetIndexStyle(3,DRAW_LINE,EMPTY, 2,C'156,255,132' );
   SetIndexStyle(4,DRAW_LINE,EMPTY, 2,C'166,237,255');
   SetIndexStyle(5,DRAW_LINE,EMPTY, 2,C'132,175,255' );
   SetIndexStyle(6,DRAW_LINE,EMPTY, 2,C'209,147,255');
   SetIndexStyle(7,DRAW_ARROW,EMPTY, 2,C'255,121,255');

}


   SetIndexArrow(7,172);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);   
   SetIndexEmptyValue(6,0.0);   
   SetIndexEmptyValue(7,0.0);   

if (Color1==1)
{
   SetIndexStyle(5,DRAW_LINE,DRAW_LINE, 1,Green );
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_LINE,DRAW_LINE, 1,Red );
   SetIndexEmptyValue(6,0.0);
}     


   SetIndexShift(0,xdist*Period1);
   SetIndexDrawBegin(0,xdist*Period1+MA_Period);
   SetIndexShift(1,xdist*Period1);
   SetIndexDrawBegin(1,xdist*Period1+MA_Period);
   SetIndexShift(2,xdist*Period1);
   SetIndexDrawBegin(2,xdist*Period1+MA_Period);
   SetIndexShift(3,xdist*Period1);
   SetIndexDrawBegin(3,xdist*Period1+MA_Period);
   SetIndexShift(4,xdist*Period1);
   SetIndexDrawBegin(4,xdist*Period1+MA_Period);
   SetIndexShift(5,xdist*Period1);
   SetIndexDrawBegin(5,xdist*Period1+MA_Period);
   SetIndexShift(6,xdist*Period1);
   SetIndexDrawBegin(6,xdist*Period1+MA_Period);
   SetIndexShift(7,xdist*Period1);
   SetIndexDrawBegin(7,xdist*Period1+MA_Period); 
 
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

 
   IndicatorShortName("Strukture-1");
   SetIndexDrawBegin(0,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtBullBuffer);
   SetIndexBuffer(1,ExtBull1Buffer);   
   SetIndexBuffer(2,ExtBull2Buffer); 
   SetIndexBuffer(3,ExtBull3Buffer);   
   SetIndexBuffer(4,ExtBull4Buffer);   
   SetIndexBuffer(5,ExtBull5Buffer); 
   SetIndexBuffer(6,ExtBull6Buffer);
   SetIndexBuffer(7,ExtBull7Buffer); 
       
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {

   ExtCountedBars=IndicatorCounted();

if (Period1<2)Period1=2;
MA_Period=Period1;
sd1=-Period1/2;
r1=Period1*4;

if (Bars1!=0)
{
bars2=r1*Bars1;

if ( bars2<(Bars-razmer-ExtCountedBars-1) ) bars2=(Bars-razmer-ExtCountedBars-1)-bars2;

}
limit=(Bars-razmer-ExtCountedBars-1-bars2);


if (Refresh!=0 && special!=Low[1])
{
special=Low[1];
limit=bars2;
if (Bars1==0){limit=Bars;}
for(r=Bars; r>=0; r--)
{
lolka();
ExtBullBuffer[r]=0;
ExtBull1Buffer[r]=0;
ExtBull2Buffer[r]=0;
ExtBull3Buffer[r]=0;
ExtBull4Buffer[r]=0;
ExtBull5Buffer[r]=0;
ExtBull6Buffer[r]=0;
ExtBull7Buffer[r]=0;
}
}



f1();//   

f2();//   

f3();//    

f4();
return(0);
}




void f1()
{
for(r=limit; r>=0; r--)
{

  k1=0;
  z=0;
 for(s=r; s>=0; s--)
{
lolka();
 if (Bear>Bear2 && Bull>Bull4 )k1+=1;    
 if (Bear<=Bear2 && Bull<=Bull4)k1+=1;
 if (k1>=l*k3 && l >= r1 ) z=1;
 if (k1<l*k3 && l >= r1 ) break;
}
w0=(l/k1);
we=(r-s);
   if (Future==1 && z==1)
      {
      s1=s;
      s=0;
      for(s=s1; s>=0; s--)
         {
         lolka();
         if (Bear>Bear2 && Bull>Bull4 )k1+=1;    
         if (Bear<=Bear2 && Bull<=Bull4)k1+=1;
         if (k1<l*Futurek4 ) break;
         }
      w0=(l*Futurek4)/k1;
      we=(r-s);
      }

   if (z==1)
   {
   ExtBull6Buffer[r+xdist*Period1]=w0;
   ExtBull5Buffer[r+xdist*Period1]=we;
   }

}

}


void f2()
{
for(r=limit; r>=0; r--)
{
if (ExtBull6Buffer[r+xdist*Period1]!=0 && ExtBull6Buffer[r+xdist*Period1-1]==0 && ExtBull6Buffer[r+xdist*Period1+1]==0)
{
ExtBull7Buffer[r+xdist*Period1]=ExtBull6Buffer[r+xdist*Period1];
}

if (ExtBull6Buffer[r+xdist*Period1]!=0 && ExtBull6Buffer[r+xdist*Period1-1]!=0 && ExtBull6Buffer[r+xdist*Period1+1]==0)
   {
   for(s=r; s>=r-200; s--)
      {
      if (ExtBull6Buffer[s+xdist*Period1]==0) break;
      }
      
n10=10000;
n20=0;
for(s1=r; s1>=s+1; s1--)
{
if ((ExtBull5Buffer[s1+xdist*Period1] > n20) || (ExtBull6Buffer[s1+xdist*Period1] < n10 && ExtBull5Buffer[s1+xdist*Period1] >= n20-1))
{
n10=ExtBull6Buffer[s1+xdist*Period1];
n20=ExtBull5Buffer[s1+xdist*Period1];
wq=s1+xdist*Period1;
}
}
ExtBull7Buffer[wq]=n10;
}

}
}

void f3()
{
for(r=Bars; r>=0; r--)
{
lolka();

ExtBull5Buffer[r]=0;
ExtBull6Buffer[r]=0;


if (ExtBull7Buffer[r+xdist*Period1]!=0) ExtBull7Buffer[r+xdist*Period1]=Bull0;

}
}

void f4()
{
for(r=limit; r>=0; r--)
{


k1=0;
z=0;
for(s=r; s>=0; s--)
{
lolka();
if (Bear>Bear2 && Bull>Bull4 )k1+=1;    
if (Bear<=Bear2 && Bull<=Bull4)k1+=1;
if (k1>=l*k3 && l >= r1 ) z=1;
if (k1<l*k3 && l >= r1 ) break;
}


if (Future==1 && z==1)
{
s1=s;
s=0;
for(s=s1; s>=0; s--)
{
lolka();
if (Bear>Bear2 && Bull>Bull4 )k1+=1;    
if (Bear<=Bear2 && Bull<=Bull4)k1+=1;
if (k1<l*Futurek4 ) break;
}
}

if (ExtBull7Buffer[r+xdist*Period1]!=0 && z==1)
{
s1=s;
s=0;
o=0;




d=0;

if (o==0)
{
for(s=r+xdist*Period1; s>=s1+xdist*Period1; s--)
{
if (s==xdist*Period1) d=1;
}
}

if (m==0 && o==0)

{
for(s=r+xdist*Period1; s>=s1+xdist*Period1; s--)
{
lolka();
ExtBullBuffer[s]=Bear4;
//ExtBull7Buffer[r+xdist*Period1]=Bull0;
if (Mirror==1) ExtBullBuffer[((r-s+2*xdist*Period1)+r)]=Bear5;

}
m=1;
o=1;
}
if (m==1 && o==0)
{
for(s=r+xdist*Period1; s>=s1+xdist*Period1; s--)
{
lolka();
ExtBull1Buffer[s]=Bear4;
//ExtBull7Buffer[r+xdist*Period1]=Bull0;
if (Mirror==1) ExtBull1Buffer[((r-s+2*xdist*Period1)+r)]=Bear5;
}
m=2;
o=1;
}


if (m==2 && o==0)
{
for(s=r+xdist*Period1; s>=s1+xdist*Period1; s--)
{
lolka();
ExtBull2Buffer[s]=Bear4;
//ExtBull7Buffer[r+xdist*Period1]=Bull0;
if (Mirror==1) ExtBull2Buffer[((r-s+2*xdist*Period1)+r)]=Bear5;
}
m=3;
o=1;
}

if (m==3 && o==0)
{
for(s=r+xdist*Period1; s>=s1+xdist*Period1; s--)

{
lolka();
ExtBull3Buffer[s]=Bear4;
//ExtBull7Buffer[r+xdist*Period1]=Bull0;
if (Mirror==1) ExtBull3Buffer[((r-s+2*xdist*Period1)+r)]=Bear5;
}
m=4;
o=1;
}

if (m==4 && o==0)
{
for(s=r+xdist*Period1; s>=s1+xdist*Period1; s--)
{
lolka();
ExtBull4Buffer[s]=Bear4;
//ExtBull7Buffer[r+xdist*Period1]=Bull0;
if (Mirror==1) ExtBull4Buffer[((r-s+2*xdist*Period1)+r)]=Bear5;
}

m=5;
if (Color1==1) m=0;

o=1;
}

if (m==5 && o==0)
{
for(s=r+xdist*Period1; s>=s1+xdist*Period1; s--)
{
lolka();
ExtBull5Buffer[s]=Bear4;
//ExtBull7Buffer[r+xdist*Period1]=Bull0;
if (Mirror==1) ExtBull5Buffer[((r-s+2*xdist*Period1)+r)]=Bear5;
}
m=6;
o=1;
}

if (m==6 && o==0)
{
for(s=r+xdist*Period1; s>=s1+xdist*Period1; s--)
{
lolka();
ExtBull6Buffer[s]=Bear4;
//ExtBull7Buffer[r+xdist*Period1]=Bull0;
if (Mirror==1) ExtBull6Buffer[((r-s+2*xdist*Period1)+r)]=Bear5;
}
m=0;
o=1;
}






if (d==1 && xdist!=0)
{
a7=0;
if (m!=0) 
{
m=m-1;
a7=1;
}
if (m==0 && a7!=1)
{
m=6;

if (Color1==1) m=4;


a7=0;
}
for(s=xdist*Period1; s>=0; s--)
{
lolka();
if (m==0)ExtBullBuffer[s]=Bear3;
if (m==1)ExtBull1Buffer[s]=Bear3;
if (m==2)ExtBull2Buffer[s]=Bear3;
if (m==3)ExtBull3Buffer[s]=Bear3;
if (m==4)ExtBull4Buffer[s]=Bear3;
if (m==5)ExtBull5Buffer[s]=Bear3;
if (m==6)ExtBull6Buffer[s]=Bear3;
}



if (Center==1)
{

for(s=(xdist*Period1)*2; s>=0; s--)
{
lolka();
if (ExtBull7Buffer[r-s+xdist*Period1*2+r]!=0 ) ExtBull7Buffer[s]=Bear3;
}
}

a7=0;
if (m==6) 
{
m=0;
a7=1;
}
if (m!=6 && a7!=1)
{
m=m+1;
a7=0;
}
if (Color1==1)
{
s=xdist*Period1;
lolka();
ty=(iHigh(NULL,0,0)-iLow(NULL,0,0))/2+iLow(NULL,0,0);
ty1=Bear8;
if (ty>ty1)y1=ty-ty1;
if (ty<ty1)y1=ty-ty1;

for(s=xdist*Period1; s>=0; s--)
{
lolka();
ExtBull5Buffer[s]=Bear7+y1;
ExtBull6Buffer[s]=Bear6+y1;
}


}

}




}


}
}



void lolka()
{

Bull=iMA(NULL,0,MA_Period,sd1+1,MA_Method,4,s);
Bull4=iMA(NULL,0,MA_Period,sd1+1,MA_Method,4,s+1);

Bull0=iMA(NULL,0,MA_Period,sd1+1,MA_Method,4,r);
Bull5=iMA(NULL,0,MA_Period,sd1+1,MA_Method,4,r+1);
Bull6=iMA(NULL,0,MA_Period,sd1+1,MA_Method,4,r+2);

Bear=iMA(NULL,0,MA_Period,sd1,MA_Method,4,r)-iMA(NULL,0,MA_Period,sd1,MA_Method,4,((r-s)+r))+iMA(NULL,0,MA_Period,sd1,MA_Method,4,r);
Bear1=iMA(NULL,0,MA_Period,sd1,MA_Method,4,((r-s)+r) );
Bear2=iMA(NULL,0,MA_Period,sd1,MA_Method,4,r)-iMA(NULL,0,MA_Period,sd1,MA_Method,4,((r-(s+1))+r))+iMA(NULL,0,MA_Period,sd1,MA_Method,4,r);

Bear3=iMA(NULL,0,MA_Period,sd1,MA_Method,4,r)-iMA(NULL,0,MA_Period,sd1,MA_Method,4,((r-s+xdist*Period1)+r))+iMA(NULL,0,MA_Period,sd1,MA_Method,4,r);
Bear6=iMA(NULL,0,MA_Period,sd1,MA_Method,4,r)-iHigh(NULL,0,((r-s+xdist*Period1)+r))+iMA(NULL,0,MA_Period,sd1,MA_Method,4,r);
Bear7=iMA(NULL,0,MA_Period,sd1,MA_Method,4,r)-iLow(NULL,0,((r-s+xdist*Period1)+r))+iMA(NULL,0,MA_Period,sd1,MA_Method,4,r);
Bear8=iMA(NULL,0,MA_Period,sd1,MA_Method,4,r)-((iHigh(NULL,0,((r-s+xdist*Period1)+r))-iLow(NULL,0,((r-s+xdist*Period1)+r)))+iLow(NULL,0,((r-s+xdist*Period1)+r)))+iMA(NULL,0,MA_Period,sd1,MA_Method,4,r);





Bear4=Bear3;
Bear5=iMA(NULL,0,MA_Period,sd1,MA_Method,4,((r-s+xdist*Period1)+r) );



l=r-s;


}


